<template>
  <div :style="{width: widthTable}">
    <table style="width: 100%">
      <thead>
      <tr @click="onSort">
        <slot/>
      </tr>
      </thead>
      <tbody>
        <slot name="first_row"/>
        <slot name="body" v-for="(row, index) in rows" :item="row" :index="index"/>
        <slot name="end_row"/>
      </tbody>
    </table>
    <template v-if="lastPage > 1">
      <uib-pagination
        v-if="lastPage > 1"
        v-model="pagination"
        :items-per-page="perPage"
        :max-size="chunk"
        :total-items="totalRecord"
        class="product__paginate"
        :boundary-links="true"
        previous-text=''
        next-text=''
        @change="fetch()">
      </uib-pagination>
    </template>
  </div>
</template>

<script>

  export default {
    props: {
      getData: {
        type: Function,
      },
      limit: {
        type: Number,
        default: 10
      },
      chunk: {
        type: Number,
        default: 6
      },
      widthTable: {
        type: String,
        default: '100%'
      },
      msgEmptyData: {
        type: String
      }
    },
    data() {
      return {
        pagination: {},
        maxPageWidth: 10,
        totalRecord: 0,
        lastPage: 0,
        page: 1,
        perPage: 10,
        column: 0,
        fetching: false,
        rows: [],
        params: {},

        orderBy: null,
        sortedBy: null,
      };
    },
    methods: {
      onPageChange(page) {
        this.page = page;
        this.fetch();
      },

      getTarget(target) {
        let node = target;
        while (node.parentNode.nodeName !== 'TR') {
          node = node.parentNode;
        }
        return node;
      },

      getSortOrder(target) {
        let sortOrder = target.dataset.sortOrder;
        switch (sortOrder) {
          case 'asc':
            sortOrder = '';
            break;
          case 'desc':
            sortOrder = 'asc';
            break;
          default:
            sortOrder = 'desc';
        }
        return sortOrder;
      },

      setSortOrders(target, sortOrder) {
        let iterator = target.parentNode.firstChild;
        while (iterator) {
          iterator.dataset.sortOrder = '';
          iterator = iterator.nextElementSibling;
        }
        target.dataset.sortOrder = sortOrder;
      },

      onSort(event) {
        const target = this.getTarget(event.target);
        const orderBy = target.dataset.sortField;
        if (!orderBy) {
          return
        }
        this.sortedBy = this.getSortOrder(target);
        this.orderBy = this.sortedBy ? orderBy : '';
        Object.assign(this.params, {sortField: this.orderBy, sortDirection: this.sortedBy});
        this.setSortOrders(target, this.sortedBy);
        this.fetch();
      },

      fetch() {
        const meta = {
          page: this.pagination.currentPage || 1,
          limit: this.limit
        };

        this.fetching = true;
        this.getData(Object.assign(meta, this.params)).then((res) => {
          this.page = parseInt(res.meta.current_page);
          this.totalRecord = parseInt(res.meta.total);
          this.lastPage = parseInt(res.meta.last_page);
          this.perPage = parseInt(res.meta.per_page);
          this.rows = [...res.data] || [];

          this.$emit('DataTable:finish');
        }).then((res) => {
          this.fetching = false;
        });
      },
      refresh() {
        this.page = 1;
        this.params = {};
        this.fetch();
      },

      filter(params) {
        this.page = 1;
        this.params = params;
        this.fetch();
      }
    },
    created() {
      this.fetch();
      this.$on('DataTable:filter', (params) => {
        this.filter(params);
      });
    },
    mounted() {
      this.column = _.chain(this.$slots.default).filter((el) => {return el.tag === 'th'}).value().length;
    }
  };
</script>

<style lang="scss" scoped>
  th[data-sort-order='desc']::after {
    content: '';
    display: inline-block !important;
    width: 14px;
    height: 14px;
    background-size: cover;
    position: relative !important;
    background-image: url(/images/icon/arrow-top.png);
    top: 2px;
  }

  th[data-sort-order='asc']::after {
    content: '';
    display: inline-block !important;
    width: 14px;
    height: 14px;
    background-size: cover;
    position: relative !important;
    background-image: url(/images/icon/arrow-top.png);
    top: 2px;
    transform: rotate(180deg);
  }
</style>
